/*
    cmd Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "device/at9s_pro.h"
#include "module/config.h"
#include "module/chassis.h"
#include "module/gimbal.h"
#include "module/shoot.h"

//#define DEAD_AREA 0.05f
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
DEVICE_AT9S_t at9s_out;
Shoot_CMD_t cmd_for_shoot;
//Chassis_Cmd_t cmd_for_chassis;
Gimbal_CMD_t cmd_for_gimbal;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_cmd(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / CMD_FREQ;

  osDelay(CMD_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */

  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
	osMessageQueueGet(task_runtime.msgq.cmd.rc, &at9s_out, NULL, 0);
	 	  
	switch (at9s_out.data.key_G) {
    case AT9S_CMD_SW_DOWN:
      cmd_for_gimbal.mode = GIMBAL_MODE_RELAX;
      cmd_for_gimbal.delta_yaw = 0.0f;
      cmd_for_gimbal.delta_pit = 0.0f;
      break;
    case AT9S_CMD_SW_MID:
      cmd_for_gimbal.mode = GIMBAL_MODE_ABSOLUTE;
      cmd_for_gimbal.delta_yaw = -at9s_out.data.ch_l_x * 2.0f;
      cmd_for_gimbal.delta_pit = -at9s_out.data.ch_l_y * 1.5f;
      break;
    case AT9S_CMD_SW_UP:
      cmd_for_gimbal.mode = GIMBAL_MODE_ABSOLUTE;
      cmd_for_gimbal.delta_yaw = -at9s_out.data.ch_l_x * 2.0f;
      cmd_for_gimbal.delta_pit = -at9s_out.data.ch_l_y * 1.5f;
      break;
    default:
      cmd_for_gimbal.mode = GIMBAL_MODE_RELAX;
      cmd_for_gimbal.delta_yaw = 0.0f;
      cmd_for_gimbal.delta_pit = 0.0f;
      break;
    }

	switch (at9s_out.data.key_C) {
    case AT9S_CMD_SW_DOWN:
		  cmd_for_shoot.online = at9s_out.online;
      cmd_for_shoot.ready = true;
      cmd_for_shoot.firecmd = true;
      break;
    case AT9S_CMD_SW_MID:
		  cmd_for_shoot.online = at9s_out.online;
      cmd_for_shoot.ready = true;
      cmd_for_shoot.firecmd = false;
      break;
    case AT9S_CMD_SW_UP:
		  cmd_for_shoot.online = at9s_out.online;
      cmd_for_shoot.ready = false;
      cmd_for_shoot.firecmd = false;
      break;
    default:
		  cmd_for_shoot.online = at9s_out.online;
      cmd_for_shoot.ready = false;
      cmd_for_shoot.firecmd = false;
      break;
    }
//switch (at9s_from_rc.data.key_E) {
//      case AT9S_CMD_SW_DOWN:
//          cmd_for_chassis.mode = CHASSIS_MODE_RELAX;
//          break;
//      case AT9S_CMD_SW_MID:
//          cmd_for_chassis.mode = CHASSIS_MODE_FOLLOW_GIMBAL;
//          break;
//      case AT9S_CMD_SW_UP:
//          cmd_for_chassis.mode = CHASSIS_MODE_ROTOR;
//          break;
//      default:
//          cmd_for_chassis.mode = CHASSIS_MODE_RELAX;
//          break;
//    }
//    cmd_for_chassis.ctrl_vec.vx = at9s_from_rc.data.ch_l_y;
//    cmd_for_chassis.ctrl_vec.vy = at9s_from_rc.data.ch_l_x;
//    cmd_for_chassis.ctrl_vec.wz = at9s_from_rc.data.ch_r_x;
    
    osMessageQueuePut(task_runtime.msgq.gimbal.cmd, &cmd_for_gimbal, 0, 0);
    osMessageQueuePut(task_runtime.msgq.shoot.cmd, &cmd_for_shoot, 0, 0);
//	    osMessageQueueReset(task_runtime.msgq.chassis.cmd);
//    osMessageQueuePut(task_runtime.msgq.chassis.cmd, &cmd_for_chassis, 0, 0);

    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}